var fs = require("fs");

exports.loadConfig = function (conffile) {
	
	global.repoproxy = new Object();
	global.repoproxy.listenPort = 8008;
	global.repoproxy.cacheDir = "./cache";
	global.repoproxy.repo = new Object();
	global.repoproxy.scancache = 1; 
	
	var confFileData = fs.readFileSync(conffile, "utf8");
	
	// first split the file on carriage returns;
	var confLines = confFileData.split("\n");
	
	// go thru each line looking for config vars
	for(var i=0; i<confLines.length; i++) {
		
		// trim a line down
		var line_one = confLines[i].trim();
		
		// split it up with :'s
		var line_real = line_one.replace(/#.*/,"").split(":");
		
		// parse the line
		switch(line_real[0]) {
		case "repo":
			
			// TODO: VALIDATE!
			console.log("Adding repo: '/%s' type '%s' from '%s', with update interval of '%s' days, and expire time of '%s' days.", line_real[1], line_real[2], line_real[3]+":"+line_real[4], line_real[5], line_real[6]);
			var thisrepo = { type : line_real[2], url: line_real[3]+":"+line_real[4], updateinterval: line_real[5], expiretime: line_real[6] };
			global.repoproxy.repo[line_real[1]] = thisrepo;
			
			break;
		case "cachedir":
			console.log("Cache dir set to: ", line_real[1]);
			global.repoproxy.cacheDir = line_real[1];
			
			break;
		case "listenport":
			console.log("Port set to: ", line_real[1]);
			global.repoproxy.listenPort = line_real[1];
			break;
		case "cachescan":
			console.log("Set cache scan rate to: '%s' hours", line_real[1]);
			global.repoproxy.scancache = parseInt(line_real[1]);
			if(global.repoproxy.scancache == 0) {
				console.log("Cache scan rate didnt make sense, it was 0, and should be at least 1 - it is set to 24, but you should check this setting");
				global.repoproxy.scancache = 24;
			}
			break;
		default:
			if(line_real[0] != "") {
				console.log("WARNING Invalid line in configuration file ignored: '%s'", line_one);
			}
		}
	}
	
	createCacheStructure();
}


function createCacheStructure() {
	try {
		var state = fs.statSync(global.repoproxy.cacheDir);
		//console.log("state is:", state);
	} catch(e) {
		try {
			fs.mkdirSync(global.repoproxy.cacheDir);
		} catch(ex) {
			console.log("ERROR: failure to create cache directory, '%s'", global.repoproxy.cacheDir);
		}
	}
	
	for(var index in global.repoproxy.repo) {
		var fullDir = global.repoproxy.cacheDir + "/" + index;
		try {
			var state = fs.statSync(global.repoproxy.cacheDir);
			//console.log("state is:", state);
		} catch(e) {
			try {
				fs.mkdirSync(fullDir);
			} catch(ex) {
				console.log("ERROR: failed to create cache directory, '%s' for '%s'", fullDir, index);
			}
		}
	}
}